<?php 
require_once (MODULE_PATH . "mdl_dchk/const.php");
ini_set("display_errors","1");
class LC_Helper_Mdl_Dchk{

    function LC_Helper_Mdl_Dchk(){
    
    }
    
    function setConfig(&$objFormParam) {
        $objQuery = new SC_Query();
        $sqlval = array();
        $arrConfig = $objFormParam->getHashArray();
        $sqlval['sub_data'] = serialize($arrConfig);
        $objQuery->update("dtb_module", $sqlval, "module_code = ?", array("mdl_dchk"));
    }

    function getConfig() {
        $objQuery = new SC_Query();
        $arrRet = $objQuery->select("sub_data", "dtb_module", "module_code = ?", array("mdl_dchk"));
        $arrConfig = unserialize($arrRet[0]['sub_data']);
        unset($objQuery);
        return $arrConfig;
    }

    function getConvenienceArray(){
        global $DCHK_CONVENIENCE_ARRAY;
        return $DCHK_CONVENIENCE_ARRAY;
    }
    
    function getPaymentArray(){
        global $DCHK_PAYMENT_ARRAY;
        return $DCHK_PAYMENT_ARRAY;
    }

    function getLimitDateArray(){
        global $DCHK_LIMITDATE_ARRAY;
        return $DCHK_LIMITDATE_ARRAY;
    }    

    function log($msg, $data = null, $suffix = '') {
        $path = DATA_PATH . "logs/mdl_dchk" . "$suffix.log";
        GC_Utils_Ex::gfPrintLog($msg, $path);

        if (!is_null($data)) {
            GC_Utils_Ex::gfPrintLog(print_r($data, true), $path);
        }
    }

    function getTemplateDir($tpl_file) {
        if(SC_MobileUserAgent::isMobile()) {
            $dir = 'mobile/'; 
        }else{
            $dir = 'pc/';
        }

        return MODULE_PATH . "mdl_dchk/templates/".$dir . $tpl_file;
    }

    function POST($target,$arrSendData){
        if(!ini_get("allow_url_fopen")){
            LC_Helper_Mdl_Dchk::log('fsockopenでデータ送信');
            $target = parse_url($target);
            $res = "";
            $fp = fsockopen("ssl://".$target["host"], 443, $errno, $errstr, 60);
            if (!$fp) {
                $this->arrErr +=array("message"=> "エラーが発生しました：".$errstr);
                LC_Helper_Mdl_Dchk::log("エラーが発生しました：".$errstr);
            } else {
                $out =   "POST ".$target["path"]." HTTP/1.1\r\n"
                        ."Host: ".$target["host"]."\r\n"
                        ."Path: ".$target["path"]."\r\n"
                        ."Content-type: application/x-www-form-urlencoded\r\n"
                        ."Content-length: " . strlen(http_build_query($arrSendData)) . "\r\n"                                    
                        ."Connection: close\r\n"
                        ."\r\n".http_build_query($arrSendData)."\r\n";
                fwrite($fp, $out);
                LC_Helper_Mdl_Dchk::log("送信データ：".$out);
                while (!feof($fp)) {
                    $res .= fgets($fp, 4096);
                }
                fclose($fp);
                LC_Helper_Mdl_Dchk::log("受信データ：".$res);
                $res = explode("\r\n\r\n",$res);
                unset($res[0]);
                $res = implode("\r\n\r\n",$res);
            }
        }else{
            LC_Helper_Mdl_Dchk::log('file_get_contentsでデータ送信');
            $options = array('http' => array(
                'method' => 'POST',
                'content' => http_build_query($arrSendData),
            ));
            LC_Helper_Mdl_Dchk::log("送信データ：".mb_convert_encoding(print_r($arrSendData,1),"UTF-8","SJIS"));
            $res = file_get_contents($target,false,stream_context_create($options));
            LC_Helper_Mdl_Dchk::log("受信データ：".$res);
        }
        return $res;
    }
    
    function sendRedirect($url, $arrQueryString = array()) {

        $netUrl = new Net_URL($url);
        $arrQueryString = array_merge($netUrl->querystring, $arrQueryString);
        $netUrl->querystring = array();

        foreach ($arrQueryString as $key => $val) {
            $netUrl->addQueryString($key, $val);
        }

        $url = $netUrl->getURL();

        header("Location: $url");
        exit;
    }

    function sfUpdateOrderStatus($orderId, $newStatus = null, $newAddPoint = null, $newUsePoint = null, &$sqlval){
        $objQuery = new SC_Query();
        $sqlval["status"] = $newStatus;
        $objQuery->update("dtb_order",$sqlval,"order_id = ? ",array($order_id));
    }

    function rollbackOrder($order_id, $orderStatus = ORDER_CANCEL, $is_delete = false) {
        $objQuery = new SC_Query();
        $objQuery->begin();
        
        $arrParams['status'] = $orderStatus;
        if ($is_delete) {
            $arrParams['del_flg'] = 1;
        }

        $objQuery->update("dtb_order",$arrParams,"order_id = ?",array($order_id));

        $arrOrderDetail = $objQuery->getRow("dtb_order_temp", "*", "order_id = ?",array($order_id));
        foreach ($arrOrderDetail as $arrDetail) {
            $objQuery->update('dtb_products_class', array(),
                              "product_class_id = ?", array($arrDetail['product_class_id']),
                              array('stock' => 'stock + ?'), array($arrDetail['quantity']));
        }

        $objQuery->commit();
        return $uniqid;
    }

    function getOrder($order_id, $customer_id = null) {
        $objQuery = new SC_Query();
        $where = 'order_id = ?';
        $arrValues = array($order_id);
        if (strlen($customer_id) > 0) {
            $where .= ' AND customer_id = ?';
            $arrValues[] = $customer_id;
        }
        $rs  = $objQuery->SELECT("*",'dtb_order',$where, $arrValues);
        return $rs[0];
    }
    
    function getOrderDetail($order_id){
        $objQuery = new SC_Query();
        $res = $objQuery->SELECT("*" , "dtb_order_detail","order_id = ?" , array($order_id));
        return $res;
    }

    function remoteIpCheck($remote_addr, $allow_addr_range)
    {
        $arr = explode("/", $allow_addr_range);
        if (count($arr) != 2)
        {
            return false;
        }
        if ( ((ip2long($remote_addr)>>(32-$arr[1])) ^ (ip2long($arr[0])>>(32-$arr[1]) )) == 0)
        {
            return true;
        } else {
            return false;
        }
    }

}