<?php
require_once (CLASS_PATH . 'pages/admin/LC_Page_Admin.php');
require_once (MODULE_PATH . "mdl_dchk/class/helper/LC_Helper_Mdl_Dchk.php");
ini_set("display_errors","1");
class LC_Page_Admin_Mdl_Dchk_Config extends LC_Page_Admin{

    // }}}
    // {{{ functions

    /**
     * Page を初期化する.
     *
     * @return void
     */
    function init() {
        parent::init();
        $this->tpl_mainpage = MODULE_PATH . "mdl_dchk/templates/config.tpl";
        $this->tpl_subtitle = "ペイデザイン決済モジュール設定";
        $this->tpl_subnavi  = 'system/subnavi.tpl';
        $this->tpl_mainno   = 'system';
        $this->tpl_subno    = 'dchk';

        $this->arrConvenience = LC_Helper_Mdl_Dchk::getConvenienceArray();
        $this->arrPayment = LC_Helper_Mdl_Dchk::getPaymentArray();
        $this->cc_uid = array('false' => '無効', 'true' => '有効');
        $this->server_ip = $_SERVER['SERVER_ADDR'];
        $this->arrLimitdate = LC_Helper_Mdl_Dchk::getLimitDateArray();
    }

    /**
     * Page のプロセス.
     *
     * @return void
     */
    function process() {
        $objView  = new SC_AdminView();
        $objFormParam = new SC_FormParam();
        $this->initParam($objFormParam);
        $objFormParam->setParam($_POST);
        
        switch ($_POST['mode']) {
            case 'edit':
                $this->arrErr =  $this->checkError($objFormParam);
                if(count($this->arrErr) == 0){
                    $this->lfUpdatePayment($objFormParam);
                    $this->arrErr = LC_Helper_Mdl_Dchk::setConfig($objFormParam);
                    if(count($this->arrErr) == 0){
                        $this->tpl_onload .= "alert('".DCHK_MESSAGE_UPDATE."');";
                        LC_Helper_Mdl_Dchk::log("決済モジュールの設定を変更しました。",$objFormParam->getHashArray());
                    }else{
                        $this->tpl_onload .= "alert('".DCHK_ERROR_CONFIG_UPDATE."');";
                        LC_Helper_Mdl_Dchk::log("決済モジュールの設定の変更に失敗しました。",$objFormParam->getHashArray());
                    }
                }
                break;
                
            default:
                $objFormParam->setParam(LC_Helper_Mdl_Dchk::getConfig());
                break;
        }
        $this->arrForm = $objFormParam->getFormParamList();
        $objView->assignobj($this);
        $objView->display(MAIN_FRAME);

    }

    /**
     * デストラクタ.
     *
     * @return void
     */
    function destroy() {
        parent::destroy();
    }

    function initParam(&$objFormParam) {
        $objFormParam->addParam("利用決済", "payment", "", "");
        $objFormParam->addParam("クレジット加盟店コード", "credit_shop_id", 10, "KVa", array("SPTAB_CHECK","MAX_LENGTH_CHECK", "ALNUM_CHECK"));
        $objFormParam->addParam("クレジット加盟店パスワード", "credit_shop_pass", 10, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
        $objFormParam->addParam("売上自動確定", "credit_kakutei", "", "", array("EXIST_CHECK"),"true");
        $objFormParam->addParam("ユーザID決済", "credit_userid_settle", "", "", array("EXIST_CHECK"),"true");
        $objFormParam->addParam("コンビニ加盟店コード", "convenience_shop_id", 10, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK", "ALNUM_CHECK"));
        $objFormParam->addParam("コンビニ加盟店パスワード", "convenience_shop_pass", 10, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
        $objFormParam->addParam("利用コンビニ", "convenience");
        $objFormParam->addParam("コンビニ支払期限","limitdate",2,"n",array("MAX_LENGTH_CHECK","NUM_CHECK"));
        $objFormParam->addParam("Pay-easy加盟店コード", "payeasy_shop_id", 10, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK", "ALNUM_CHECK"));
        $objFormParam->addParam("Pay-easy加盟店パスワード", "payeasy_shop_pass", 10, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
        $objFormParam->addParam("Pay-easy支払期限","payeasy_limitdate",2,"n",array("MAX_LENGTH_CHECK","NUM_CHECK"));
    }

    function checkError(&$objFormParam){
        $arrErr = $objFormParam->checkError();
	
        // コンビニ選択確認
        $arrPayment = $objFormParam->getHashArray();
        if(is_array($arrPayment["payment"]) AND in_array("convenience",$arrPayment["payment"]) > 0){
            if(!is_array($arrPayment["convenience"]) OR count($arrPayment["convenience"]) == 0){
                $arrErr["convenience"] = DCHK_ERROR_CONVENIENCE_SELECT;
            }
            if(strlen($arrPayment["limitdate"]) == 0){
                $arrErr["limitdate"] = DCHK_ERROR_CONVENIENCE_LIMIT;
            }
            if(strlen($arrPayment["convenience_shop_id"]) == 0){
                $arrErr["convenience_shop_id"] = DCHK_ERROR_CONVENIENCE_ID;
            }
            if(strlen($arrPayment["convenience_shop_id"]) == 0){
                $arrErr["convenience_shop_pass"] = DCHK_ERROR_CONVENIENCE_PASS;
            }
        }
        //クレジット選択時
        if(is_array($arrPayment["payment"]) AND in_array("credit",$arrPayment["payment"]) > 0){
            if(strlen($arrPayment["credit_shop_id"]) == 0){
                $arrErr["credit_shop_id"] = DCHK_ERROR_CREDIT_ID;
            }
            if(strlen($arrPayment["credit_shop_id"]) == 0){
                $arrErr["credit_shop_pass"] = DCHK_ERROR_CREDIT_PASS;
            }        
        }
        //Pay-easy選択時
        if(is_array($arrPayment["payment"]) AND in_array("payeasy",$arrPayment["payment"]) > 0){
            if(strlen($arrPayment["payeasy_shop_id"]) == 0){
                $arrErr["payeasy_shop_id"] = DCHK_ERROR_PAYEASY_ID;
            }
            if(strlen($arrPayment["payeasy_shop_id"]) == 0){
                $arrErr["payeasy_shop_pass"] = DCHK_ERROR_PAYEASY_PASS;
            }
            if(strlen($arrPayment["payeasy_limitdate"]) == 0){
                $arrErr["payeasy_limitdate"] = DCHK_ERROR_PAYEASY_LIMIT;
            }
        }
        return $arrErr;
    }
    
    //決済手段更新
    function lfUpdatePayment(&$objFormParam){
        $objQuery = new SC_Query();
        $newArrPayment = $objFormParam->getValue("payment");
        $objSession = new SC_Session();
        
        foreach($this->arrPayment as $key => $payment){
            if($key == "credit"){
                $charge_flg = 2;
            }else{
                $charge_flg = 1;
            }
            switch($key){
                case "convenience":
                    $upper_rule_max = DCHK_CONVENIENCE_UPPER;
                    $note = "";
                    break;
                case "credit":
                    $upper_rule_max = DCHK_CREDIT_UPPER;
                    if ($objFormParam->getValue("credit_userid_settle")=="true")
                    {
                        $note = '<input type="checkbox" name="use_regcard" value="1" /><label for="use_regcard">前回の買い物で使用したカード情報を利用する</label>';
                    } else {
                        $note = "";
                    }
                    break;
                case "payeasy":
                    $upper_rule_max = DCHK_PAYEASY_UPPER;
                    $note = '';
                    break;
                default:
                    $upper_rule_max = 1000000;
            }
            if(is_array($newArrPayment) AND in_array($key,$newArrPayment)){
                $sqlval = array(
                     "payment_method" => $payment
                    ,"fix" => 3
                    ,"creator_id" => $objSession->member_id
                    ,"create_date" => "now()"
                    ,"update_date" => "now()"
                    ,"module_path" => MODULE_PATH . "mdl_dchk/".$key.".php"
                    ,"del_flg" => "0"
                    ,"memo03" => 1
                    ,"note" =>$note
                    ,"charge_flg" => $charge_flg
                    ,"upper_rule_max" => $upper_rule_max
                    ,"module_code" => "mdl_dchk"
                    ,"module_id"   => DCHK_MODULE_ID
                );
                $payment_id = $objQuery->select("payment_id", "dtb_payment", "module_code = ? AND module_path = ?", array("mdl_dchk",MODULE_PATH . "mdl_dchk/".$key.".php"));
                if( count($payment_id)  == 0 ){//追加
                    $max_rank = $objQuery->getOne("SELECT max(rank) FROM dtb_payment");
                    $sqlval += array("rank" => $max_rank + 1);
                    $objQuery->insert("dtb_payment",$sqlval);
                }else{//更新
                    $objQuery->update("dtb_payment",$sqlval,"payment_id = ?",array($payment_id[0]["payment_id"]));
                }
            }else{
                $sqlval = array(
                    "del_flg" => 1
                );
                $objQuery->update("dtb_payment",$sqlval,"module_code = ? AND module_path = ? AND del_flg = 0",array("mdl_dchk",MODULE_PATH . "mdl_dchk/".$key.".php"));
            }
        }
    }

}