<?php
require_once (CLASS_PATH . 'pages/LC_Page.php');
require_once (MODULE_PATH . "mdl_dchk/class/helper/LC_Helper_Mdl_Dchk.php");

class LC_Page_Mdl_Dchk extends LC_Page {

    /**
     * Page を初期化する.
     *
     * @return void
     */
    function init() {
        parent::init();
        $arrConfig = LC_Helper_Mdl_Dchk::getConfig();
        foreach($arrConfig as $key=>$val){
            $this->$key = $val;
        }
        LC_Helper_Mdl_Dchk::log('モジュール処理開始。');
    }


    /**
     * Page のプロセス.
     *
     * @return void
     */
    function process() {
        parent::process();
        $this->action();
    }

    /**
     * Page のプロセス.
     *
     * @return void
     */
    function mobileProcess() {
        parent::process();
        $this->action();
    }

    /**
     * デストラクタ.
     *
     * @return void
     */
    function destroy() {
        parent::destroy();
    }

    /**
     * Page のアクション.
     *
     * @return void
     */
    function action() {

        $objSiteSess = new SC_SiteSession();
        // EC-CUBE確認画面からの遷移
        $order_id = $_SESSION['order_id'];
        LC_Helper_Mdl_Dchk::log('受注ID:'.$order_id);

        if($_GET["return"] == 1){
            $this->rollbackOrder($order_id);
            $objSiteSess->setRegistFlag();
            $this->sendRedirect($this->getLocation(SHOPPING_PAYMENT_URLPATH));
            exit;
        }


        if ($_SERVER['REQUEST_METHOD'] === 'GET') {
            // 戻りパラメータがある時
            if ($this->checkRetParam($_GET)) {
                LC_Helper_Mdl_Dchk::log('DCHKからの戻り値:'.print_r($_GET, true));
                // 正常完了処理
                $objSiteSess->setRegistFlag();

                $this->completeSettlement($order_id);
                LC_Helper_Mdl_Dchk::log('完了ページに移動します');
                $this->sendRedirect($this->getLocation(SHOPPING_COMPLETE_URLPATH));

            } else if ($_GET['transactionid']) {
                LC_Helper_Mdl_Dchk::log("オーダーURL：".$this->getOrderUrl()."へリダイレクトします");
                // データ作成
                $arrSendData = $this->createSendData($order_id);
                LC_Helper_Mdl_Dchk::log("パラメータ：".print_r($arrSendData, 1));
                // 送信先URLへリダイレクト
                LC_Helper_Mdl_Dchk::sendRedirect($this->getOrderUrl(),$arrSendData);
            } else {
                LC_Helper_Mdl_Dchk::log('パラメータが不正です:'.print_r($_GET,true));
                $this->rollbackOrder($order_id);
                $this->sendRedirect($this->getLocation(SHOPPING_CONFIRM_URLPATH));
            }
        } else {
            // POSTの場合
            LC_Helper_Mdl_Dchk::log('不正な'.$_SERVER['REQUEST_METHOD'].'リクエストを受信しました');
            $this->rollbackOrder($order_id);
            $this->sendRedirect($this->getLocation(SHOPPING_CONFIRM_URLPATH));
        }
    }

    function checkRetParam($params) {

        if ($params['SID'] > 0) {
            return true;
        }
        return false;
    }

    /**
     * 購入商品情報を取得します.
     * @param unknown_type $order_id
     */
    function createOrderDetailData($order_id) {

        global $DCHK_PAYMENT_ARRAY;

        $objQuery = new SC_Query();
        // 受注基本情報を取得
        $arrOdr = $this->getOrder($order_id,$objQuery);
        // 受注詳細情報を取得
        $arrOrder = $this->getOrderDetail($order_id,$objQuery);
        LC_Helper_Mdl_Dchk::log("商品件数：".count($arrOrder));
        $arrRet = array(
            "N1"=>"",
            "K1"=>0
        );
        foreach($arrOrder as $value) {
            if ($arrOdr['payment_method'] === $DCHK_PAYMENT_ARRAY['payeasy'])
            {
                $arrRet['N1'] = $this->toRegularProductString($this->kigou2zenkaku($value['product_name']),19);
            } else {
                $arrRet['N1'] = $this->toRegularProductString($value['product_name'],19);
            }
          $arrRet['K1'] += SC_Utils_Ex::sfPreTax($value['price']) * $value['quantity'];
        }
        $arrOrder = $this->getOrder($order_id,$objQuery);
        $arrRet['K1'] += $arrOrder['deliv_fee'];
        $arrRet['K1'] += $arrOrder['charge'];
        $arrRet['K1'] -= $arrOrder['use_point'] * POINT_VALUE;

/*  コンビニダイレクト 外付け手数料対応時は下記コメントアウト解除 */
/*
        if ($arrOrder['payment_method'] == $DCHK_PAYMENT_ARRAY['convenience'])
        {
            $arrRet['K1'] -= $arrOrder['charge'];
        }
*/

/*  ペイジーダイレクト 外付け手数料対応時は下記コメントアウト解除 */
/*
        if ($arrOrder['payment_method'] == $DCHK_PAYMENT_ARRAY['payeasy'])
        {
            $arrRet['K1'] -= $arrOrder['charge'];
        }
*/

        return $arrRet;
    }

    /**
     * 送信データを生成します。
     * @param unknown_type $order_id
     */
    function createSendData($order_id) {

        // 送信データを作成
        $arrSendData = array(
            'IP' => $this->shop_id,
            'SID' => $order_id,
            'FUKA' => '', //  付加情報
            'STORE' => $this->getStore(), // 決済方法
            'OKURL' => $this->getOkUrl(), //  完了URL
            'RT' => $this->getReturnUrl() // 戻りURL
        );
        $sendData = Array_Merge($arrSendData , $this->getOrderData($order_id), $this->createOrderDetailData($order_id), $this->getExtData());
        return $sendData;
    }

    /**
     * 発注データを取得します.
     */
    function getOrderData($order_id) {

        $objQuery = new SC_Query();
        // 受注情報を取得
        $arrData = $this->getOrder($order_id,$objQuery);
        $arrSendData = array(
            'NAME1' => $this->toRegularString($arrData["order_name01"], 10),
            'NAME2' => $this->toRegularString($arrData["order_name02"], 10),
            'KANA1' => $this->toRegularString($arrData["order_kana01"], 10),
            'KANA2' => $this->toRegularString($arrData["order_kana02"], 10),
            'YUBIN1' => $arrData["order_zip01"],
            'YUBIN2' => $arrData["order_zip02"],
            'TEL' => $arrData["order_tel01"].$arrData["order_tel02"].$arrData["order_tel03"],
            'ADR1' => $this->toRegularString($arrData["order_addr01"], 25),
            'ADR2' => $this->toRegularString($arrData["order_addr02"], 25),
            'MAIL' => $arrData["order_email"],
        );
        return $arrSendData;
    }

    /**
     *
     * 発注ステータスを完了にします。
     * @param unknown_type $order_id
     */
    function completeSettlement($order_id) {
        $sqlval = array(
            'payment_date' => 'now()', // 入金日時
            'update_date' => 'now()',
            'dchk_status' =>DCHK_STATUS_WAIT
        );
        LC_Helper_Mdl_Dchk::log('update order status: ORDER_PRE_END');
        $objPurchase = new SC_Helper_Purchase_Ex();
        $objPurchase->sfUpdateOrderStatus($order_id, ORDER_PRE_END, null, null, $sqlval);
    }

    function rollbackOrder($order_id) {
        LC_Helper_Mdl_Dchk::log('rollback order');
        $objQuery = new SC_Query();
    }

    /**
     * 決済方法、中身はサブクラスで実装
     */
    function getStore() {return true;}

    /**
     * 完了URL
     */
    function getOkUrl() {
      return SSL_URL.'shopping/load_payment_module.php?'.TRANSACTION_ID_NAME."=".$this->transactionid;
    }

    /**
     * 戻りURL
     */
    function getReturnUrl() {
      return SSL_URL.'shopping/load_payment_module.php?return=1&'.TRANSACTION_ID_NAME.'='.$this->transactionid;
    }

    /**
     * 送信先URLを取得、中身はサブクラスで実装
     */
    function getOrderUrl() {return true;}


    /**
     * 決済ごとの独自情報、中身はサブクラスで実装
     */
    function getExtData() {return true;}

    /**
     * 文字列を正規化します。
     * ・「半角」英数字を「全角」に変換
     * ・「半角カタカナ」を「全角カタカナ」に変換
     * ・指定文字列に切り取り
     * ・文字コードをSJISに変換
     * @param unknown_type 文字列
     * @param unknown_type 文字数
     */
    function toRegularString($str, $length){

        $strConv = mb_convert_kana($str, "AKV");
        $strConv = str_replace(" ","　",$strConv);
        $strConv = mb_substr($strConv, 0, $length);
        return $this->toSjis($strConv);
    }

    /**
     * 文字列を正規化します。
     * ・半角\を全角に変換
     * ・指定文字列に切り取り
     * ・文字コードをSJISに変換
     * @param unknown_type 文字列
     * @param unknown_type 文字数
     */
    function toRegularProductString($str, $length){

        $strConv = str_replace("\\", "￥", $str);
        $strConv = mb_substr($strConv, 0, $length);
        return $this->toSjis($strConv);
    }

    function toSjis($str) {
      return mb_convert_encoding($str,"SJIS","UTF-8");
    }
    
    function getOrder($order_id,&$objQuery){
        $ret = $objQuery->SELECT("*","dtb_order","del_flg = 0 AND order_id = ?",array($order_id));
        return $ret[0];
    }
    
    function getOrderDetail($order_id,&$objQuery){
        $ret = $objQuery->SELECT("*","dtb_order_detail","order_id = ?",array($order_id));
        return $ret;
    }

    /**
     * 文字列を正規化します。
     * ・「半角」記号を「全角」に変換
     * @param unknown_type 文字列
     */
    function kigou2zenkaku( $str ){

        $before = array('!', '"', '#', '\$', '%', '&', "'", '\(', '\)', '=', '~', '\|', '-', '\^', '\\\\',
            '`', '\{', '@' , '\[', '\+', '\*', '}', ';', ':', ']', '<', '>', '\?', '_', ',', '\.', '/', '｢', '｣');
        $after = array('！', '”', '＃', '＄', '％', '＆', '’', '（', '）', '＝', '～', '｜', '－', '＾', '￥',
            '｀', '｛', '＠', '［', '＋', '＊', '｝', '；', '：', '］', '＜', '＞', '？', '＿', '，', '．', '／', '「', '」');
        foreach( $before as $i=>$pattern ){
            $replacement = $after[$i];
            $str = mb_ereg_replace( $pattern, $replacement, $str );
        }
        return $str;
    }
}
