<?php
require_once MODULE_PATH . 'mdl_dchk/class/pages/LC_Page_Mdl_Dchk.php';

class LC_Page_Mdl_Dchk_Convenience extends LC_Page_Mdl_Dchk {
    
    /**
     * 決済方法を取得します。
     */
    function getStore() {
      return $this->store;
    }
    
    function action(){
        if(SC_MobileUserAgent::isMobile()){
            $mobile = true;
            $objView = new SC_MobileView();
        }else{
            $mobile = false;
            $objView = new SC_SiteView();
        }
        $this->tpl_mainpage = LC_Helper_Mdl_Dchk::getTemplateDir('convenience.tpl');
        $this->shop_id = $this->convenience_shop_id;
        $this->shop_pass = $this->convenience_shop_pass;

        $objSiteSess = new SC_SiteSession();

        $objFormParam = new SC_FormParam();
        $this->initParam($objFormParam);
        $objFormParam->setParam($_POST);
        $this->arrConvenience = LC_Helper_Mdl_Dchk::getConvenienceArray();
        $objQuery = new SC_Query();

        foreach($this->arrConvenience as $key=>$val){
            if(!in_array($key,$this->convenience)){
                unset($this->arrConvenience[$key]);
            }
        }
        
        $order_id = $_SESSION['order_id'];
        $arrOrderData = $this->getOrder($order_id,$objQuery);

        if ($arrOrderData['payment_total'] == 0) {
            $this->skipSettlement($order_id,$mobile);
        }

        switch ($_POST['mode']) {
            case "return":
                $objSiteSess->setRegistFlag();
                $this->sendRedirect($this->getLocation(URL_SHOP_CONFIRM ),$mobile);
                exit;
                break;
            case "send": 
                //エラーチェック
                $this->arrErr = $objFormParam->checkError();
                if(count($this->arrErr) == 0){
                    // データ作成
                    $this->store = $objFormParam->getValue("convenience");
                    $arrSendData = $this->createSendData($order_id);
                    // 送信先URLへPOST
                    $res = LC_Helper_Mdl_Dchk::POST(DCHK_CONVENIENCE_URL,$arrSendData);
                    $res = explode("\r\n", mb_convert_encoding($res,"UTF-8","SJIS"));
                    if(is_array($res) and count($res) >= 3 ){
                        if($res[0] == "OK"){
                            $objSiteSess->setRegistFlag();
                            $this->setCompleteParam($res);
                            $this->sendRedirect($this->getLocation(URL_SHOP_COMPLETE),$mobile);
                        }else{
                            $this->arrErr["message"] = $res[2];
                        }
                    }else{
                        $this->arrErr["message"] =  DCHK_ERROR_CONVENIENCE_CONNECT ;
                    }
                }
                break;
            default:
                break;
                
        }
        $this->arrForm = $objFormParam->getFormParamList();
        $objView->assignobj($this);
        $objView->display(SITE_FRAME);
    }


    /**
     * 決済ごとの独自情報を取得します。
     */
    function getExtData() {
        $limit = date("Ymd",( time() + 86400 * $this->limitdate));
        return array('KAKUTEI' => 1,"KIGEN"=>$limit);
    }
    

    function initParam(&$objFormParam) {
        $objFormParam->addParam("利用コンビニ", "convenience",INT_LEN,"KVa",array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));	
    }

    function setCompleteParam($res) {
        $order_id = $_SESSION['order_id'];

        if ( !$order_id or !SC_Utils_Ex::sfIsInt($order_id)) {
            return;
        } 

        $objQuery = new SC_Query();
        $this->arrOther = array(
            "title"=>array("value"=>"コンビニ決済情報","name"=>"コンビニ決済"),
//            "支払期限"=>array("value"=>$res[4],"name"=>"支払期限"),
            "指定コンビ二"=>array("value"=>$this->arrConvenience[$this->store],"name"=>"指定コンビ二")
        );
//ここから追加部分
        if($this->store == "71"){
        $this->arrOther += array("お支払方法"=>array("value"=>"次のURLを携帯電話に転送してコンビニでお支払ください。","name"=>"お支払方法"));
        }else{
        $this->arrOther += array("お支払方法"=>array("value"=>"次の番号を紙などに控えてコンビニにてお支払ください。","name"=>"お支払方法"));
        }
        switch ($this->store) {
          case '1':
            $this->arrOther += array("受付番号"=>array("value"=>"<font color='red'>".$res[3]."</font>","name"=>"受付番号"));
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("ローソン支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/lawson.html target='_blank'>http://www.paydesign.co.jp/service/guide/lawson.html</a>","name"=>"ローソンでのお支払方法"));
            $this->arrOther += array("セイコーマート支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/seico.html target='_blank'>http://www.paydesign.co.jp/service/guide/seico.html</a>","name"=>"セイコーマートでのお支払方法"));
            $this->arrOther += array("ミニストップ支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/ministop.html target='_blank'>http://www.paydesign.co.jp/service/guide/ministop.html</a>\n","name"=>"ミニストップでのお支払方法"));
          break;
          case '2':
            $this->arrOther += array("払込票番号"=>array("value"=>"<font color='red'>".$res[3]."</font>","name"=>"払込票番号"));        
            $this->arrOther += array("払込票"=>array("value"=>'<a href='.$res[6].' target="_blank">'.$res[6]."</a>","name"=>"払込票"));        
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("セブン支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/seven.html target='_blank'>http://www.paydesign.co.jp/service/guide/seven.html</a>\n","name"=>"セブンイレブンでのお支払方法"));
          break;
          case '3':
            $this->arrOther += array("第1番号（企業コード） - 第2番号（注文番号）"=>array("value"=>"<font color='red'>".$res[3]."</font>","name"=>"第1番号（企業コード） - 第2番号（注文番号）"));
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("ファミマ支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/famima.html target='_blank'>http://www.paydesign.co.jp/service/guide/famima.html</a>\n","name"=>"ファミリーマートでのお支払方法"));
          break;
          case '71':
            $this->arrOther += array("支払用バーコードURL"=>array("value"=>'<a href='.$res[6].' target="_blank">'.$res[6]."</a>","name"=>"支払用バーコードURL"));
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("ａｍｐｍ支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/ap.html target='_blank'>http://www.paydesign.co.jp/service/guide/ap.html</a>","name"=>"ａｍｐｍでのお支払方法"));
            $this->arrOther += array("ヤマザキ支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/yamazaki.html target='_blank'>http://www.paydesign.co.jp/service/guide/yamazaki.html</a>\n","name"=>"デイリーヤマザキ・ヤマザキデイリーストアーでのお支払方法"));
          break;
          case '73':
            $this->arrOther += array("オンライン決済番号"=>array("value"=>"<font color='red'>".$res[3]."</font>","name"=>"オンライン決済番号"));        
            $this->arrOther += array("支払期限"=>array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"));
            $this->arrOther += array("オンライン決済支払方法"=>array("value"=>"<a href=http://www.paydesign.co.jp/service/guide/onlinekessai.html target='_blank'>http://www.paydesign.co.jp/service/guide/onlinekessai.html</a>\n","name"=>"サークルKサンクス・デイリーヤマザキ・ヤマザキデイリーストアーでのお支払方法"));
          break;
        }
//ここまで追加部分
/*
        if($this->store == "71"){
            $this->arrOther += array("支払用URL"=>array("value"=>'<a href='.$res[6].' target="_blank">'.$res[6]."</a>","name"=>"支払用URL"));
        }else{
            $this->arrOther += array("支払番号"=>array("value"=>$res[3],"name"=>"支払番号"));        
        }
*/
        $sqlval = array(
                    "memo06"=>$res[3],  //結果コード
                    "memo02"=> serialize($this->arrOther) ,  //支払期限など
                    "status"=>ORDER_PAY_WAIT ,
                    "dchk_status" =>DCHK_STATUS_WAIT
                  );
        LC_Helper_Mdl_Dchk::log("決済結果書き込み： order_id ".$order_id."：".print_r($sqlval, 1));
        $objQuery->update('dtb_order',$sqlval, 'order_id = ?', array($order_id));
    }

    //決済金額が0円の時は決済をスキップ
    function skipSettlement($order_id,$mobile) {
        LC_Helper_Mdl_Dchk::log('決済金額が0円のため決済処理をスキップします。');
        $sqlval = array(
            'update_date' => 'now()',
            'dchk_status' => DCHK_STATUS_WAIT,
            'status'=> ORDER_NEW
        );
        $objQuery = new SC_Query();
        $objQuery->update('dtb_order',$sqlval, 'order_id = ?', array($order_id));

        $objSiteSess = new SC_SiteSession();
        $objSiteSess->setRegistFlag();
        LC_Helper_Mdl_Dchk::log('完了ページに移動します');
        $this->sendRedirect($this->getLocation(URL_SHOP_COMPLETE),$mobile);
   }
}
?>
