<?php
require_once(realpath(dirname(__FILE__)). '/LC_Page_Mdl_Dchk.php');

class LC_Page_Mdl_Dchk_Payeasy extends LC_Page_Mdl_Dchk {

    function action(){
        if(SC_MobileUserAgent::isMobile()){
            $mobile = true;
            $objView = new SC_MobileView();
        }else{
            $mobile = false;
            $objView = new SC_SiteView();
        }

        $objSiteSess = new SC_SiteSession();
        $objCustomer = new SC_Customer();
        $objParam    = new SC_FormParam();
        $objQuery = new SC_Query();
        
        $order_id = $_SESSION['order_id'];
        $this->transactionid = $this->getToken();
        $arrOrderData = $this->getOrder($order_id,$objQuery);

        if ($arrOrderData['payment_total'] == 0) {
            $this->skipSettlement($order_id,$mobile);
        }

        // POSTデータを送信し、応答情報を取得する
        // データ作成
        $arrSendData = $this->createSendData($order_id);
        $response = LC_Helper_Mdl_Dchk::POST($this->getOrderUrl(), $arrSendData);

        // なにも返ってこなれば、エラー
        if ($response == "") {
            // エラー画面を表示する。
            $_SESSION['site']['now_page'] ="";
            $this->rollbackOrder($order_id);
            LC_Helper_Mdl_Dchk::log("URL:$order_url サーバーからの応答がありません");
            $this->arrEr = array("message"=>"サーバーからの応答がありません");
            $this->viewError($objView);
            exit;
        }
        $arrResponse = explode("\r\n", mb_convert_encoding($response,"UTF-8", "SJIS"));
        if ($arrResponse[0] != "OK") {
            $this->rollbackOrder($order_id);
            LC_Helper_Mdl_Dchk::log(mb_convert_encoding(print_r($response,1),"UTF-8","SJIS"));
            if (mbereg(".*PRERROR.*", $response))  {
                $this->arrEr = array("message"=>"パラメータエラーです。[メッセージ：".$arrResponse[2]."]");
                LC_Helper_Mdl_Dchk::log("パラメータエラーです。[メッセージ：".mb_convert_encoding(print_r($arrResponse,1),"UTF-8","SJIS")."]");
            } else {
                $this->arrEr = array("message"=>"システムエラーです。[メッセージ：".$arrResponse[2]."]");
                LC_Helper_Mdl_Dchk::log("システムエラーです。[メッセージ：".mb_convert_encoding(print_r($arrResponse,1),"UTF-8","SJIS")."]");
            }
            $objSiteSess->setRegistFlag();
            $this->viewError($objView);
//            $this->tpl_mainpage = LC_Helper_Mdl_Dchk::getTemplateDir('credit_error.tpl');
//            $objView->assignobj($this);
//            $objView->display(SITE_FRAME);
            exit;
        } else {
            LC_Helper_Mdl_Dchk::log('Pay-easy決済完了。完了ページに移動します');
            $objSiteSess->setRegistFlag();
            $this->completeSettlement($order_id,$arrResponse);
            $this->sendRedirect($this->getLocation(URL_SHOP_COMPLETE),$mobile);
            exit;
        }
    }

    function viewError(&$objView) {
        $this->tpl_mainpage = LC_Helper_Mdl_Dchk::getTemplateDir('credit_error.tpl');
        $objView->assignobj($this);
        $objView->display(SITE_FRAME);
    }

    /**
     * 決済方法を取得します。
     */
    function getStore() {
      return "84";
    }

    /**
     * 決済ごとの独自情報を取得します。
     */
    function getExtData() {
        $limit = date("Ymd",( time() + 86400 * $this->payeasy_limitdate));
        return array('KIGEN' => $limit);
    }
    
    /**
     * 送信データを生成します。
     * @param unknown_type $order_id
     */
    function createSendData($order_id) {
        $this->shop_id = $this->payeasy_shop_id;
        $this->shop_pass = $this->payeasy_shop_pass;
        // 送信データを作成
        $arrSendData = array(
            'IP' => $this->shop_id,
            'SID' => $order_id,
            'FUKA' => '', //  付加情報
            'STORE' => $this->getStore() // 決済方法
        );
        $sendData = Array_Merge($arrSendData , $this->getOrderData($order_id), $this->createOrderDetailData($order_id), $this->getExtData());
        return $sendData;
    }


    /**
     * 発注データを取得します.
     */
    function getOrderData($order_id) {

        $objQuery = new SC_Query();
        // 受注情報を取得
        $arrData = $this->getOrder($order_id,$objQuery);
        $kana1 = mb_convert_kana($arrData["order_kana01"],"AKVC");
        $kana2 = mb_convert_kana($arrData["order_kana02"],"AKVC");
        $kana1 = str_replace(" ","　",$kana1);
        $kana2 = str_replace(" ","　",$kana2);        
        $arrSendData = array(
            'NAME1' => $this->toRegularString($arrData["order_name01"], 10),
            'NAME2' => $this->toRegularString($arrData["order_name02"], 10),
            'KANA1' => $this->toSjis($kana1, 10),
            'KANA2' => $this->toSjis($kana2, 10),
            'YUBIN1' => $arrData["order_zip01"],
            'YUBIN2' => $arrData["order_zip02"],
            'TEL' => $arrData["order_tel01"].$arrData["order_tel02"].$arrData["order_tel03"],
            'ADR1' => $this->toRegularString($arrData["order_addr01"], 25),
            'ADR2' => $this->toRegularString($arrData["order_addr02"], 25),
            'MAIL' => $this->toSjis( mb_convert_kana($arrData["order_email"], "a"))
        );
        return $arrSendData;
    }

    /**
     * 送信先URLを取得します。
     * @see LC_Page_Mdl_Dchk::getOrderUrl()
     */
    function getOrderUrl() {
      return DCHK_PAYEASY_URL;
    }

    //完了時のステータス設定
    function completeSettlement($order_id,$res) {
        $objQuery = new SC_Query();
        $payCode = explode("-",$res[3]);
        $this->arrOther = array(
            "title"=>array("value"=>"Pay-easy決済情報","name"=>"Pay-easy決済"),
            "お支払方法" => array("value"=>"次の番号を紙などに控えて金融機関にてお支払ください。","name"=>"お支払方法"),
            "収納機関番号" => array("value"=>$payCode[0],"name"=>"収納機関番号"),
            "お客様番号" => array("value"=>$payCode[1],"name"=>"お客様番号"),
            "確認番号" => array("value"=>$payCode[2],"name"=>"確認番号"),
            "支払期限" => array("value"=>"<font color='red'>".substr($res[4],0,4)."/".substr($res[4],4,2)."/".substr($res[4],-2)."</font>\n","name"=>"お支払期限"),
            "確認ページURL" => array("value"=>'<a href="'.$res[6].'" target="_blank">'.$res[6].'</a>',"name"=>"確認ページURL")
        );
        $sqlval = array(
            "memo02"=> serialize($this->arrOther) ,  //支払期限など
            'update_date' => 'now()',
            'dchk_status' => DCHK_STATUS_WAIT,
            'status'      => ORDER_PAY_WAIT
        );
        LC_Helper_Mdl_Dchk::log("決済結果書き込み： order_id ".$order_id."：".print_r($sqlval, 1));
        $objQuery->update('dtb_order',$sqlval, 'order_id = ?', array($order_id));
    }

    //決済金額が0円の時は決済をスキップ
    function skipSettlement($order_id,$mobile) {
        LC_Helper_Mdl_Dchk::log('決済金額が0円のため決済処理をスキップします。');
        $sqlval = array(
            'update_date' => 'now()',
            'dchk_status' => DCHK_STATUS_WAIT,
            'status'=> ORDER_NEW
        );
        $objQuery = new SC_Query();
        $objQuery->update('dtb_order',$sqlval, 'order_id = ?', array($order_id));

        $objSiteSess = new SC_SiteSession();
        $objSiteSess->setRegistFlag();
        LC_Helper_Mdl_Dchk::log('完了ページに移動します');
        $this->sendRedirect($this->getLocation(URL_SHOP_COMPLETE),$mobile);
   }
}
?>
